$ ! ALW_STARTUP.COM -- Apple LaserWriter queue startup
$ !
$ ! Dan Newman, Ned Freed, Innosoft International, Inc., 27 Nov 1989
$ !
$ !
$ ! This is a sample command file to startup  the  Apple  LaserWriter  print
$ ! symbiont.   The  symbiont  is  ALWSMB.EXE  and  it must be stored on the
$ ! logical device SYS$SYSTEM: .
$ !
$ ! About the MATHLIB BURSAR charge  back  accounting  system:   The  source
$ ! files  JBCSUBS.C  and  SYMBIONT.C  have  a few lines of code which the C
$ ! pre-processor  will  only  include   if   you    DEFINE   the   quantity
$ ! MATHLIB_ACCOUNTING,
$ !
$ !     $ CC/DEFINE=("MATHLIB_ACCOUNTING") JBCSUBS.C
$ !     $ CC/DEFINE=("MATHLIB_ACCOUNTING") SYMBIONT.C
$ !
$ ! These lines of code, when compiled, will cause the symbiont to  use  the
$ ! MATHLIB BUSAR database for charge back accounting.  Users will be billed
$ ! PS_GIBBS_COST per page when they print documents.   If  a  user  is  not
$ ! authorized  in  the database to use the resource PS_GIBBS_RESOURCE, they
$ ! will not be allowed to print anything on that "resource".  Similarly, if
$ ! they  have  expended  their  funds in PS_GIBBS_DEFAULT_DEPARTMENT (or in
$ ! whatever  department  they  specify),  they  will  be  denied   printing
$ ! privileges.   Note  that  individual  users  may  be  granted  unlimited
$ ! printing privileges.  The number of pages printed by  "unlimited"  users
$ ! will still, however, be recorded in the database.
$ !
$ !
$ !
$ !
$ ! Define a logical pointing to the printer
$ !
$ define/system/executive PS__GIBBS  _TTA2:
$ !
$ !
$ !
$ ! The next two logicals must be  defined  regardless  of  whether  or  not
$ ! MATHLIB  BURSAR database is used.  If the database is not used, then the
$ ! logicals x_COST and  x_DEPARTMENT_DEFAULT  should  be  set  to  "0"  and
$ ! "NONE".    x  is  the  name  of  the  print  queue  specified  with  the
$ ! INITIALIZE/QUEUE command; here, in this command file, x is PS_GIBBS.  If
$ ! you  do  use  the database, x_GIBBS_COST should be the cost per page for
$ ! printing and x_DEPARTMENT_DEFAULT should be the default department  name
$ ! (e.g.,  "MATHEMATICS")  against  which  to bill printed pages.  (See the
$ ! BURSAR documentation for an explanation of how billing works.)
$ !
$ !
$ define/system PS_GIBBS_COST               	"0"
$ define/system PS_GIBBS_DEPARTMENT_DEFAULT 	"NONE"
$ !
$ !
$ !
$ ! If you use the MATHLIB BURSAR  charge  back  accounting  database,  then
$ ! uncomment  the next two lines.  BURSAR_DIR should point to the directory
$ ! where the MATHLIB BURSAR database is stored.  This logical should be  an
$ ! executive  mode  logical  to  prevent users from overriding it (and thus
$ ! defeating the billing system).  x_RESOURCE is the resource name for  the
$ ! printer in the database.   (Note, the other logicals are translated only
$ ! once when the  symbiont is first started up;  thus, there is no  need to
$ ! to  worry  about  users  overriding  them  with  process  level  logical
$ ! definitions.)
$ !
$ !define/system/executive BURSAR_DIR		MATHLIB_ROOT:[exe]
$ !define/system PS_GIBBS_RESOURCE           	CSVLASER
$ !
$ !
$ !
$ ! Now set some characteristics for the terminal line going to the printer.
$ ! THE DEVICE MUST NOT BE SET SPOOLED!
$ !
$ set terminal /permanent PS__GIBBS -
               /pasthru -
               /eightbit -
               /nobroadcast -
               /altypeahd -
               /noecho -
               /nowrap -
               /width=511
$ !
$ !
$ !
$ ! Now initialize the queue.
$ !
$ initialize /queue PS_GIBBS -
             /device=terminal -
             /noenable_generic -
             /default=(noflag,feed) -
             /processor=alwsmb -
             /on=PS__GIBBS -
             /start
$ !
$ ! We're all done!
$ exit
